# era009-inf214oblig2
INF214 Lab 3 (Obligatory 2)
Name: Eirik Ravnskog

Task 1

Thread is a class that extends Object and implements Runnable. An object thread is a thread of execution in a program. Running concurrently, threads with higher priority are executed in preference to threads with lower priority. 

Runnable is designed to provide a common protocol for objects that wish to execute code while they are active. Being active simply means that a thread has been started and has not yet been stopped. Any class, whose instances are intended to be executed be a thread, should implement the Runnable interface. The class must also define a method run with no arguments. 

InterruptedException: This exception is thrown when a thread is waiting, sleeping, or otherwise occupied. The thread is interrupted before or during the activity. 

Speed-up for my concurrent program (in milliseconds): 
12682 (for SerialMult)
6572 (for MatrixMult)


Task 2

2.1 

InvertedIndex is a ConcurrentHashMap – a hash table supporting full concurrency of retrievals and high expected concurrency for updates. 

2.2 

Callable<Result> is, like Runnable, an interface designed for classes whose instances can be executed by another thread. Callable also returns a result and may throw an exception. 

DocumentParser is a parser for HTML Documents that reads an InputStream of HTML, invokes the suitable methods in the ParserCallback class, and messages the callback for all valid tags. 

getAbsolutePath() is a function that returns the absolute pathname of the given file object. 

2.3 

take() retrieves and removes the Future representing the next completed task, waiting if none are yet present. 
Runnable: see task 1 for a definition.  

Thread.interrupted() returns the current thread’s interrupted status and clears the interrupt flag. 

A Future represent the result of an asynchronous computation. The result is retrieved by get() when the computation has completed (Document document = future.get();).

Poll() retrieves and removes the Future representing the next completed task or null if none are present. 

StringBuffer is a thread-safe, mutable sequence of characters. 

keySet() creates a set out of the key elements contained in the hash map (from the class IndexingTask). 

computeIfAbsent(Key, Function) computes values for a given key using the given mapping function (k -> new StringBuffer()). If the key is present and a non-null value is related to the key, then it returns that value. If the key is not present in the map or a null value is related to the key, then it tries to compute the value using the mapping function. 

InterruptedException: see task 1.  

2.4 

ExecutorCompletionService<Document> is a CompletionService that uses a supplied Executor to execute tasks. Upon completion, submitted task are placed on a queue accessible using take(). 

ConcurrentHashMap<String, StringBuffer> is a hash table that supports full concurrency of retrievals and high expected concurrency for updates. All operations are thread-safe, but retrieval operations do not entail locking. 

ThreadPoolExecutor executes each submitted task using one of possibly several pooled threads, and maintains some basic statistics, such as the number of completed tasks. 

InvertedIndexTask implements the tasks that get the Document objects generated by the IndexTask objects and construct the inverted index. 

thread1.start() causes thread1 to be scheduled for execution. 

completionService.submit(task) submits a value-returning task for execution and returns a Future representing the pending result of the task. 

executor.shutdown() initiates an orderly shutdown – no new tasks will be accepted, but previously submitted tasks are executed. 

executor.awaitTermination(1, TimeUnit.DAYS) blocks until all tasks have completed execution after the timeout occurs. 

thread1.join() blocks the calling thread until the thread represented by this instance terminates. 


Task 3

3.1 

The printer could produce 6! = 720 different outputs

3.2 

printer() {
    process P1 { P; write("1"); write("2") V; }
    process P2 { P; write("3"); write("4") V; }
    process P3 { P; write("5"); write("6") V; }
}

Task 5 

CyclicBarrier is a synchronization aid that allows a set of threads to all wait for each other to reach a common barrier point. The barrier can be re-used after the waiting threads are released, hence the name CyclicBarrier. 

BrokenBarrierException: an exception is thrown when a thread tries to wait upon a barrier that is in a broken state, or which enters the broken state while the thread is waiting.

